/******************************************************************************
*
* (c) 2004 by BECK IPC GmbH
*
* BECK IPC GmbH
* Garbenheimerstr. 36-38
* D-35578 Wetzlar
*
* Phone: (49)-6441-905-0
* Fax:   (49)-6441-905-245
*
*******************************************************************************
*
* Disclaimer: This program is an example and should be used as such.
*             If you wish to use this program or parts of it in your application,
*             you must validate the code yourself. BECK IPC GmbH can not be held
*             responsible for the correct functioning or coding of this example.
*
* Module:     taskmon.c
* Function:   This program demonstrates the usage of the implemented
*             taskmonitoring functions of the RTOS APIc at the IPC@CHIP.
*
*******************************************************************************
*
* $Header: c:\proj2000\IPC@CHIP\Examples\rtos\TASKMON\TASKMON.C, 3, 31.03.2004 11:16:03, Andre Pribil$
*
******************************************************************************/


/******************************************************************************
* Includes
******************************************************************************/
#include <stdio.h>
#include <conio.h>
#include "clib.h"



/******************************************************************************
* Global variables
******************************************************************************/
TaskList tasklist[35];
Task_StateData taskstatedata;



/******************************************************************************
* main()
******************************************************************************/
int main(void)
{
   int i;
   int result;
   int error;
   int key=0;

   BIOS_Set_Focus( FOCUS_APPLICATION );

   printf("\r\nTask monitor example");


   while(key!=27)
   {

      //wait 10 seconds
      printf("\r\nSleeping 10 seconds");

      RTX_Start_Task_Monitor();

      for(i=0;i<5;i++)
      {
        putchar('.');
        RTX_Sleep_Time(2000);

      }
      RTX_Sleep_Time(200);   


      //get list of tasks on the system
      result=RTX_Get_Task_List(tasklist, 35);
      //read task status
      if(kbhit())key = getch();

      for(i=0;(i<result) && (key!=27);i++)
      {
        RTX_Get_Task_State(tasklist[i].taskname,&taskstatedata,&error);
        if(error==0)
        {
          printf("\r\n%s ID %04d Prio %03d Cnt %04d Stack %04d Used %02d%% State 0x%04X",
                  tasklist[i].taskname, taskstatedata.taskID,taskstatedata.taskPrio, taskstatedata.taskCount,
                  taskstatedata.stacksize, taskstatedata.stackused,taskstatedata.taskState);
        }
        else
        {
          printf("\r\nTask %s not found or monitoring not enabled Err %d",tasklist[i].taskname,error);
        }

      }

      RTX_Stop_Task_Monitor();


      printf("\r\nESC exits\r\n");
      if(kbhit())key = getch();
  }

  if(key==27) printf("\r\nUser break");
  printf("\r\nExit program\r\n");
  BIOS_Set_Focus( FOCUS_BOTH );
  return 0;
}



// End of file
