/******************************************************************************
*
* (c) 2004 by BECK IPC GmbH
*
* BECK IPC GmbH
* Garbenheimerstr. 36-38
* D-35578 Wetzlar
*
* Phone: (49)-6441-905-0
* Fax:   (49)-6441-905-245
*
*******************************************************************************
*
* Disclaimer: This program is an example and should be used as such.
*             If you wish to use this program or parts of it in your application,
*             you must validate the code yourself. BECK IPC GmbH can not be held
*             responsible for the correct functioning or coding of this example.
*
* Module:     adrlatch.c
* Function:   Example for using the hardware API. This shows how to enable the
*             ALE address latch signal.
*             This example provides the same functionality as the internal
*             "ale" RTOS command.
*
*******************************************************************************
*
* $Header: adrlatch.c, 2, 31.03.2004 11:15:31, Andre Pribil$
*
******************************************************************************/

/******************************************************************************
* Includes
******************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include "clib.h"

/******************************************************************************
* Display command line options
******************************************************************************/
void usage (void)
{
  printf("\nProgram enables/disables ALE");
  printf("\nUsage: adrlatch <0/1> ,  0=disable, 1=enable");
}

/******************************************************************************
* Main
******************************************************************************/
void main (int argc, char *argv[])
{
  unsigned char ale;

  if (argc==2)
  {
     ale = atoi(argv[1]);
     if (ale>1)
     {
       usage();
       return;
     }
  }
  else
  {
     usage();
     return;
  }

  if (ale==0)
  {
    printf("\nDisable ALE");
  }
  else
  {
    printf("\nEnable ALE");
  }


  // Enable/disable ALE
  pfe_enable_bus(0xFFFF,ale);
}

