/******************************************************************************
*
* (c) 2004 by BECK IPC GmbH
*
* BECK IPC GmbH
* Garbenheimerstr. 36-38
* D-35578 Wetzlar
*
* Phone: (49)-6441-905-0
* Fax:   (49)-6441-905-245
*
*******************************************************************************
*
* Disclaimer: This program is an example and should be used as such.
*             If you wish to use this program or parts of it in your application,
*             you must validate the code yourself. BECK IPC GmbH can not be held
*             responsible for the correct functioning or coding of this example.
*
* Module:     main.c
* Function:   Example for http client requests
*
*******************************************************************************
*
* $Header: httpmain.c, 1, 01.04.2004 16:20:16, Markus Bartat$
*
******************************************************************************/

/******************************************************************************
* Includes
******************************************************************************/
#include <stdio.h>
#include <string.h>
#include <clib.h>
#include "httpcli.h"
#include "dns.h"

/******************************************************************************/
char buffer[ MAX_HTTP_REQ_BUFLEN + 1 ];

/******************************************************************************
* Main()
******************************************************************************/
int main(int argc, char *argv[])
{

  int rslt;
  FILE *file_ptr;

  BIOS_Set_Focus( 2 );

  printf("\r\nIPC@CHIP HTTP client example\r\n");

  if( argc < 2 )
  {
     printf("\r\nInvalid or missing arguments for http request!"
            "\r\nUsage   : httpclie [user:pass@]servername[:port]/[page] [filename] [dns-server]"
            "\r\nExample : httpclie batman:spiderwoman@194.25.3.142:80/dk40 page.htm\r\n");

     goto EXIT_PROGRAM;
  }

  rslt=httpGet( argv[ 1 ], buffer, MAX_HTTP_REQ_BUFLEN, argv[ argc - 1 ] );
  if ( rslt > 0 )
  {
      if ( (  argc > 2 ) && ( strchr( argv[ 2 ], '.' ) == strrchr( argv[ 2 ], '.' ) ) )
      {
         file_ptr = fopen( argv[ 2 ], "w+" );    // second argument is file-name
         if ( file_ptr )
         {
            fprintf( file_ptr, "%s", buffer );
            if ( ferror( file_ptr ) )
               printf( "Error while writing to file %s\n", argv[2] );
            if ( fclose ( file_ptr ) != 0 )
               printf( "Error while closing file %s\n", argv[2] );
         }
         else
            printf( "Error: Couldn't open file %s\n", argv[2] );
      }
      else
         printf( "\r\nReceived\r\n%s\r\n", buffer );
  }
  else
      printf( "\r\nHttp request failed\r\n" );

EXIT_PROGRAM:
  printf( "\r\nExit program\r\n" );

  BIOS_Set_Focus( 3 );
  return 0;
}
//******************************************************************************/
//end of file
